(*Based on mkU_mkR*)
Require Export SynthesisIota.
Require Export SynthesisTheta.

Lemma UWhile_cond_svar: forall C F n s G M t K Q E
   (RS: JoinSem _ SVar_eq (s, G, M)
       (JWhile _ E
          (JComp SVar (iota C (n::F))
             (JComp SVar (mkJoins n (modVarsL C))
                (JJoin SVar (cond_svar n) (E :: nil)
                   ((cond_svar n) :: allPCs F ++ mkSVars E)
                   )))) (t, K, Q))
   (HGM: ssqsub (GEval (fun x0 : PVar => llub (G x0) (M (var_svar (progVar x0)))) E)
                       (M (cond_svar n))),
   ssqsub (M (cond_svar n)) (Q (cond_svar n)) /\
   (forall m, In m F -> m <> n -> M (cond_svar m) = Q (cond_svar m)) /\
   ssqsub (GEval (fun x0 : PVar => llub (K x0) (Q (var_svar (progVar x0)))) E)
                       (Q (cond_svar n)) /\
   (forall x, modVars C x = false -> M (var_svar (progVar x)) = Q (var_svar (progVar x))).
Proof.
intros.
               remember (s, G, M) as ST. remember (t, K, Q) as TT.
               remember (JWhile SVar E
          (JComp SVar (iota C (n :: F))
             (JComp SVar (mkJoins n (modVarsL C))
                (JJoin SVar (cond_svar n) (E :: nil)
                   (cond_svar n :: allPCs F ++ mkSVars E))))) as PP. 
               generalize dependent E.
               generalize dependent Q. generalize dependent K. generalize dependent t.
               generalize dependent M. generalize dependent G. generalize dependent s.
               induction RS; intros; try inversion HeqPP; clear HeqPP; subst.
               (*True*) clear IHRS1 RS2.
                        destruct r as [[uu AA] PP].
                         inversion RS1; subst; clear RS1.
                         inversion H5; subst; clear H5.
                         inversion H7; subst; clear H7. destruct r as [[r HH] QQ].
                         destruct (mkJoins_effect _ _ _ _ _ _ _ _ H4) as [Z1 [Z2 Z3]]. subst. clear H4.
                         assert (Z:= IHRS2 _ _ _ (eq_refl _) _ _ _ (eq_refl _) _ (eq_refl _)). clear IHRS2.
                         rewrite supd_Same in Z.
                         destruct Z.
                             rewrite GEval_sep. 
                             apply lub_leq. rewrite lab_eval_GEval. apply lub_leqleft.
                             simpl. rewrite GEval_supd_condsvar. apply lubright.
                               apply lubright. rewrite zeval_app; simpl. rewrite zeval_GEval. apply lub_leqright.
                         split. rewrite (iota_ControlLabelsPreserved C (n::F) _ (eq_refl _) _ _ _ _ _ _ H3 n).
                             eapply leq_snart. apply H0; clear H0.
                              apply lubright. apply lub_leqleft.
                           left; trivial.
                         destruct H1 as [HH1 [HH2 HH3]].
                         split. intros. rewrite <- HH1; clear HH1 HH2 HH3. rewrite supd_Diff. 
                                      rewrite <- (iota_ControlLabelsPreserved C (n::F) _ (eq_refl _) _ _ _ _ _ _ H3 m). trivial.
                                        right; trivial.
                                  intros Z; inversion Z; subst. apply H2; trivial. 
                                  trivial.
                                  trivial.
                         split. apply HH2. 
                         intros. clear HH1 HH2. rewrite <- HH3. rewrite supd_Diff; try discriminate.
                               remember (in_dec pvar_eq x (modVarsL C)) as b; destruct b. apply modVarsChar' in H1. exfalso. apply (H1 i).
                               clear HH3. eapply (iota_noMod C (n::F) _ (eq_refl _) _ _ _ _ _ _ H3).
                                  rewrite modVars_iota. assumption.
                            assumption.
                (*False*) inversion HeqTT; subst; clear HeqTT. 
                    split. apply leq_refl.
                    split; intros. trivial.
                    split. apply HGM.
                    intros; trivial.
Qed.

Lemma iota_theta: forall c Gamma Delta (tw : FPCT Gamma c Delta) F
s G M t D N (Hyp : JoinSem _ SVar_eq (s, G, M) (iota c F) (t, D, N))
s' G' t' D' (Hyp' : TntSem (s', G') (theta _ _ _ tw) (t', D'))
(HG : SQSUB (MERGE G M) (FPCCTXT2CTXT Gamma))
(HG': SQSUB G' (FPCCTXT2CTXT Gamma))
(HF: ssqsub (zeval SVar M (allPCs F)) (Gamma pcVar)),
(forall m, In m F -> M (cond_svar m) = N (cond_svar m)) /\
forall (x : PVar)
(SIM : ssimsub (MERGE D N x) (MERGE G M) G' s s'),
t x = t' x /\ ssqsub (MERGE D N x) (D' x).
Proof.
intros. (* c GG' HH' tw GG F s M t H N Hyp.*)
destruct (Iota_FPC_U2 _ _ _ tw _ _ _ _ _ _ _ Hyp HF HG) as [UU1 UU2].
generalize dependent UU2.
generalize dependent UU1.
generalize dependent HG'.
generalize dependent HG.
generalize dependent HF.
generalize dependent Hyp'.
generalize dependent D'. generalize dependent t'.
generalize dependent G'. generalize dependent s'.
generalize dependent N. generalize dependent D. generalize dependent t.
generalize dependent M. generalize dependent G. generalize dependent s.
generalize dependent F.
induction tw; simpl; intros; subst.
(*Skip*)
inversion Hyp'; subst; clear Hyp'.
inversion H; subst; clear H.
inversion Hyp; subst; clear Hyp.
split. intros; trivial.
split. apply SIM; apply leq_refl.
apply SIM; apply leq_refl.
(*Assign*)
inversion Hyp'; subst; clear Hyp'.
inversion Hyp; subst; clear Hyp.
inversion H4; subst; clear H4.
inversion H2; subst; clear H2.
simpl in *. rename G into Gamma. rename G0 into G. rename M0 into M.
split. intros. rewrite supd_Diff. trivial. discriminate.
split. apply M_upd_split_at; intros; subst.
  rewrite M_upd_Same. unfold lab_eval in SIM; simpl in SIM.
   eapply ssimsub_eval. apply SIM. clear SIM. unfold MERGE. rewrite M_upd_Same. rewrite supd_Same.
     rewrite bbot_id.
      rewrite GEval_sep.
      apply lub_leq. apply lub_leqleft.
      apply lubright. rewrite zeval_app.
         rewrite zeval_GEval. apply lub_leqright.
  rewrite M_upd_Diff; try assumption.
    eapply SIM. unfold MERGE. 
    rewrite M_upd_Diff; try assumption.
    apply lub_leq. apply lub_leqleft.
      rewrite supd_Diff. apply lub_leqright. 
    intros Z; inversion Z. apply (H H1).
rewrite M_upd_Diff in UU2; try discriminate. rewrite FPCCTXT2CTXT_upd_progVar in *.
  unfold MERGE in *. fold supd in UU2.
  rewrite allPCs_upd_progVar in UU2.
  remember (pvar_eq x x0) as b; destruct b; subst; simpl in *. repeat rewrite supd_Same in *. repeat rewrite M_upd_Same in *.  repeat rewrite M_upd_Same in SIM. fold supd in UU1.
    unfold lab_eval in *. simpl in *. repeat rewrite bbot_id in *. repeat rewrite id_bbot in *. 
    apply lub_leq. 
      eapply @leq_trans with (y:= GEval (MERGE G M) E).
        apply GEval_mono. apply MERGE_L.
      apply lubleft. eapply ssimsub_GEval. apply SIM. rewrite zeval_lub_MERGE. apply lub_leqleft.
    rewrite zeval_app. apply lub_leq. apply lubright. apply HF.
      rewrite zeval_GEval. 
      eapply @leq_trans with (y:= GEval (MERGE G M) E).
        apply GEval_mono. apply MERGE_R.
      apply lubleft. eapply ssimsub_GEval. apply SIM. rewrite zeval_lub_MERGE. apply lub_leqleft.

    rewrite supd_Diff. repeat rewrite M_upd_Diff; try assumption.
      rewrite supd_Diff in SIM.  rewrite M_upd_Diff in SIM; try assumption. apply SIM. apply leq_refl. 
      intros Z; inversion Z; subst. apply n; trivial. 
      intros Z; inversion Z; subst. apply n; trivial. 
(*Comp*) 
rename G into Gamma. rename G0 into G. rename G1 into Gamma1. rename G2 into Gamma2.
inversion Hyp'; subst; clear Hyp'. destruct r as [r' K'].
inversion Hyp; subst; clear Hyp. destruct r as [[r K] P].
assert (SUB_K':= TntSem_FPC _ _ _ tw1 _ _ _ _ H2 HG').
destruct (Iota_FPC_U2 _ _ _ tw1 _ _ _ _ _ _ _ H3 HF HG) as [Za Zb].
destruct (Iota_FPC_U2 _ _ _ tw2 _ _ _ _ _ _ _ H6 Zb Za) as [Ya Yb].
destruct (IHtw1 F _ _ _ _ _ _ H3 _ _ _ _ H2 HF HG HG' Za Zb) as [IH1a IH1b]; clear IHtw1.
destruct (IHtw2 F _ _ _ _ _ _ H6 _ _ _ _ H4 Zb Za SUB_K' Ya Yb) as [IH2a IH2b]; clear IHtw2.
split; intros. rewrite (IH1a _ H). apply (IH2a _ H).
apply IH2b. 
  intros z Hz. apply IH1b; intros y Hy; apply SIM; apply (leq_trans Hy); apply Hz.
(*Ite*)
assert (Goal1:= iota_ControlLabelsPreserved (Ite E C1 C2) F _ (eq_refl _) _ _ _ _ _ _ Hyp).
split; trivial.
repeat rewrite fpcupd_Same in UU2.
repeat rewrite fpcupd_Same in IHtw1.
repeat rewrite fpcupd_Same in IHtw2.
repeat rewrite fpcupd_Same.
repeat rewrite FPCCTXT2CTXT_upd_pcVar in IHtw1.
repeat rewrite FPCCTXT2CTXT_upd_pcVar in IHtw2.
repeat rewrite FPCCTXT2CTXT_upd_pcVar in UU1.
remember (fresh F) as Fr. destruct Fr as [n Fn].
inversion Hyp'; subst; clear Hyp'. destruct r as [r' K'].
destruct (CompCode_Lemma0 _ _ _ _ _ _ H4) as [MC1 MC2]. subst. clear H4.
inversion Hyp; subst; clear Hyp.
inversion H3; subst; clear H3.
rename G into Gamma. rename G0 into G. rename G1 into Gamma1. rename G2 into Gamma2.
repeat rewrite lab_eval_GEval in *.
assert (NinNF: In n (n::F)). left; trivial.
intros x SIM.
destruct (MC2 x) as [[MCx MVx] | [MCx MVx]]; clear MC2.
(* In x (modVarsL C1 ++ modVarsL C2)*)
  rewrite MCx in *; clear MCx. 
  assert (Q: ssqsub (llub (GEval G E) (zeval SVar M (allPCs F ++ mkSVars E))) (N (var_svar (progVar x)))).
     clear H2 IHtw1 IHtw2 SIM.
     inversion H5; subst; clear H5; simpl in *.
     (*True*) inversion H6; subst; clear H6. destruct r as [[r K] P].
        destruct (mkJoins_effect _ _ _ _ _ _ _ _ H5) as [Z1 [Z2 Z3]]. subst. clear H5.
        remember (modVars C1 x) as b1; destruct b1; apply eq_sym in Heqb1.
          assert (X:= iota_Mod' C1 (n::F) _ (eq_refl _) _ _ _ _ _ _ H2 x). rewrite modVars_iota in X.
          assert (XX:= X Heqb1 _ NinNF). clear X. rewrite supd_Same in XX.
          apply (leq_trans XX).
          remember (in_dec pvar_eq x (modVarsL C2)) as b2; destruct b2. apply lub_leqright. apply leq_refl.
        simpl in MVx.
          remember (in_dec pvar_eq x (modVarsL C2)) as b2; destruct b2.
            rewrite <- (iota_ControlLabelsPreserved C1 (n::F) _ (eq_refl _) _ _ _ _ _ _ H2 _ NinNF).
            rewrite supd_Same.
            apply lub_leqleft.
          exfalso. apply n0. apply modVarsChar. apply MVx.
     (*False*) inversion H6; subst; clear H6. destruct r as [[r K] P].
        destruct (mkJoins_effect _ _ _ _ _ _ _ _ H5) as [Z1 [Z2 Z3]]. subst. clear H5.
        remember (modVars C2 x) as b1; destruct b1; apply eq_sym in Heqb1.
          assert (X:= iota_Mod' C2 (n::F) _ (eq_refl _) _ _ _ _ _ _ H2 x). rewrite modVars_iota in X.
          assert (XX:= X Heqb1 _ NinNF). clear X. rewrite supd_Same in XX.
          apply (leq_trans XX).
          remember (in_dec pvar_eq x (modVarsL C1)) as b2; destruct b2. apply lub_leqright. apply leq_refl.
        simpl in MVx. rewrite Bool.orb_false_r in MVx.
          remember (in_dec pvar_eq x (modVarsL C1)) as b2; destruct b2.
            rewrite <- (iota_ControlLabelsPreserved C2 (n::F) _ (eq_refl _) _ _ _ _ _ _ H2 _ NinNF).
            rewrite supd_Same.
            apply lub_leqleft.
          exfalso. apply n0. apply modVarsChar. apply MVx.
  assert (LEQ_E: ssqsub (GEval (MERGE G M) E) (llub (GEval G E) (zeval SVar M (allPCs F ++ mkSVars E)))).
      rewrite zeval_lub_MERGE. apply lub_leqleft. 
  assert (EV: eval s E = eval s' E).
    clear IHtw1 IHtw2 H2 H5.
    eapply ssimsub_eval. apply SIM.
      apply (leq_trans LEQ_E). 
      apply (leq_trans Q). 
      apply lub_leqright.
  simpl in MVx.
  inversion H5; subst; clear H5; simpl in*.  
  (*True*)
    inversion H2; subst; clear H2; simpl in *.
    (*True*) 
       clear IHtw2 EV H5 H6.
       inversion H7; subst; clear H7. destruct r as [[r K] P].
       destruct (mkJoins_effect _ _ _ _ _ _ _ _ H4) as [Z1 [Z2 Z3]]. subst. clear H4.
         assert (Pn := iota_ControlLabelsPreserved _ _ _ (eq_refl _) _ _ _ _ _ _ H2 n NinNF).
         rewrite supd_Same in Pn. rewrite zeval_lub_MERGE in Pn.
         assert (U2Help: forall m : nat, In m F -> P (cond_svar m) = P (cond_svar m)). intros; trivial.
         rewrite (allPCs_conds_eq F _ P) in UU2; try apply U2Help.
         assert (Z: ssqsub (zeval SVar
           (zupd SVar SVar_eq M (cond_svar n)
              (llub (GEval G E) (zeval SVar M (allPCs F ++ mkSVars E))))
             (allPCs (n :: F)))
          (llub (Gamma pcVar) (GEval (fun x : PVar => Gamma (progVar x)) E)) ).
            rewrite zeval_lub_MERGE. simpl. rewrite supd_Same. rewrite <- zeval_allPCs_supd. Focus 2. intros Z. apply Fn. trivial.
             rewrite (@lub_assoc1 L LatL).
             apply lub_leq. apply lubright. apply GEval_mono. apply HG.
                          apply lubleft. apply HF.
         assert (ZZ: SQSUB (MERGE G
                         (zupd SVar SVar_eq M (cond_svar n)
                           (llub (GEval G E) (zeval SVar M (allPCs F ++ mkSVars E)))))
                     (FPCCTXT2CTXT
                       (fpcupd Gamma pcVar
                       (llub (Gamma pcVar) (GEval (fun x0 : PVar => Gamma (progVar x0)) E))))).
               repeat rewrite FPCCTXT2CTXT_upd_pcVar in *.  fold supd. rewrite MERGE_supd. apply HG.
         destruct (Iota_FPC_U2 _ _ _ tw1 _ _ _ _ _ _ _ H2 Z ZZ) as [HRS1 HRS2].
         repeat rewrite FPCCTXT2CTXT_upd_pcVar in *.
         assert (IH:= IHtw1 _ _ _ _ _ _ _ H2 _ _ _ _ H8 Z ZZ HG' HRS1 HRS2). clear IHtw1 H8.
         destruct IH as [IHG1 IHG2].
          destruct (IHG2 x) as [IHG3 IHG4]; clear IHG2.
             rewrite MERGE_supd. intros z Hz. apply SIM.
                eapply (leq_trans Hz). apply lub_leq. apply lub_leqleft.
                  apply lubright. 
                  remember (in_dec pvar_eq x (modVarsL C2)) as b; destruct b; subst.
                     apply lub_leqright. apply leq_refl.
           split; trivial.
           apply lub_leq. apply lubleft. eapply leq_snart. apply IHG4. apply lub_leqleft.
                  remember (in_dec pvar_eq x (modVarsL C2)) as b; destruct b; subst.
                     apply lub_leq. rewrite <- Pn. eapply leq_snart. apply lubright. apply Z.
                     simpl. rewrite supd_Same. rewrite <- zeval_lub_MERGE. apply lub_leqleft.
                  apply lubleft. eapply leq_snart. apply IHG4. apply lub_leqright.
           apply lubleft. eapply leq_snart. apply IHG4. apply lub_leqright.
     (*False*) clear H7 H8 IHtw1 IHtw2. rewrite EV in H6. rewrite H5 in H6. inversion H6.
  (*False*) clear IHtw1.
    inversion H2; subst; clear H2; simpl in *.
    (*True*) 
       clear IHtw2 H7 H8 tw1 tw2. rewrite EV in H6. rewrite H5 in H6. inversion H6.
    (*False*)
       clear EV H5 H6.
       inversion H7; subst; clear H7. destruct r as [[r K] P].
       destruct (mkJoins_effect _ _ _ _ _ _ _ _ H4) as [Z1 [Z2 Z3]]. subst. clear H4.
         assert (Pn := iota_ControlLabelsPreserved _ _ _ (eq_refl _) _ _ _ _ _ _ H2 n NinNF).
         rewrite supd_Same in Pn. rewrite zeval_lub_MERGE in Pn.
         assert (U2Help: forall m : nat, In m F -> P (cond_svar m) = P (cond_svar m)). intros; trivial.
         rewrite (allPCs_conds_eq F _ P) in UU2; try apply U2Help.
         assert (Z: ssqsub (zeval SVar
           (zupd SVar SVar_eq M (cond_svar n)
              (llub (GEval G E) (zeval SVar M (allPCs F ++ mkSVars E))))
             (allPCs (n :: F)))
          (llub (Gamma pcVar) (GEval (fun x : PVar => Gamma (progVar x)) E)) ).
            rewrite zeval_lub_MERGE. simpl. rewrite supd_Same. rewrite <- zeval_allPCs_supd. Focus 2. intros Z. apply Fn. trivial.
             rewrite (@lub_assoc1 L LatL).
             apply lub_leq. apply lubright. apply GEval_mono. apply HG.
                          apply lubleft. apply HF.
         assert (ZZ: SQSUB (MERGE G
                         (zupd SVar SVar_eq M (cond_svar n)
                           (llub (GEval G E) (zeval SVar M (allPCs F ++ mkSVars E)))))
                     (FPCCTXT2CTXT
                       (fpcupd Gamma pcVar
                       (llub (Gamma pcVar) (GEval (fun x0 : PVar => Gamma (progVar x0)) E))))).
               repeat rewrite FPCCTXT2CTXT_upd_pcVar in *.  fold supd. rewrite MERGE_supd. apply HG.
         destruct (Iota_FPC_U2 _ _ _ tw2 _ _ _ _ _ _ _ H2 Z ZZ) as [HRS1 HRS2].
        repeat rewrite FPCCTXT2CTXT_upd_pcVar in *.
         assert (IH:= IHtw2 _ _ _ _ _ _ _ H2 _ _ _ _ H8 Z ZZ HG' HRS1 HRS2). clear IHtw2 H8.
         destruct IH as [IHG1 IHG2].
          destruct (IHG2 x) as [IHG3 IHG4]; clear IHG2.
             rewrite MERGE_supd. intros z Hz. apply SIM.
                eapply (leq_trans Hz). apply lub_leq. apply lub_leqleft.
                  apply lubright. 
                  remember (in_dec pvar_eq x (modVarsL C1)) as b; destruct b; subst.
                     apply lub_leqright. apply leq_refl.
           split; trivial.
           apply lub_leq. apply lubleft. eapply leq_snart. apply IHG4. apply lub_leqleft.
                  remember (in_dec pvar_eq x (modVarsL C1)) as b; destruct b; subst.
                     apply lub_leq. rewrite <- Pn. eapply leq_snart. apply lubright. apply Z.
                     simpl. rewrite supd_Same. rewrite <- zeval_lub_MERGE. apply lub_leqleft.
                  apply lubleft. eapply leq_snart. apply IHG4. apply lub_leqright.
           apply lubleft. eapply leq_snart. apply IHG4. apply lub_leqright.

  (*~ In x (modVarsL C1 ++ modVarsL C2)*)
     unfold MERGE; simpl.
     rewrite MCx in *. simpl in MVx. apply Bool.orb_false_iff in MVx. destruct MVx as [MV1 MV2].
     destruct (JSem1 _ _ _ _ _ _ _ _ _ H5 x) as [W1 W2].
       simpl. repeat rewrite modVars_iota. repeat  rewrite modVars_mkJoins. rewrite MV1. rewrite MV2. reflexivity.
     rewrite <- W1 in *. rewrite <- W2 in *. clear W1.
     destruct (TSem1 _ _ _ _ _ H2 x) as [W1 WW2].
       simpl. repeat rewrite modVars_theta. rewrite MV1. rewrite MV2. reflexivity.
     rewrite <- W1 in *. rewrite <- WW2 in *. clear W1 WW2 H2.
     assert (MN: forall m, In m F -> M (cond_svar m) = N (cond_svar m)). apply Goal1.
     assert (W: M (var_svar (progVar x)) = (N (var_svar (progVar x)))).
        inversion H5; subst; clear H5; simpl in *.
        (*True*) clear IHtw1 IHtw2 SIM.
           inversion H6; subst; clear H6; simpl in *. destruct r as [[r K] P].
           destruct (mkJoins_effect _ _ _ _ _ _ _ _ H5) as [Z1 [Z2 Z3]]. subst. clear H5.
           assert (W:= iota_noMod _ _ _ (eq_refl _) _ _ _ _ _ _ H2 x).
             rewrite modVars_iota in W. rewrite supd_Diff in W; try discriminate.
             remember (in_dec pvar_eq x (modVarsL C2)) as b; destruct b.
               rewrite modVarsChar' in MV2. exfalso. apply (MV2 i).
             apply (W MV1).
        (*False*) clear IHtw1 IHtw2 SIM.
           inversion H6; subst; clear H6. destruct r as [[r K] P].
           destruct (mkJoins_effect _ _ _ _ _ _ _ _ H5) as [Z1 [Z2 Z3]]. subst. clear H5.
           assert (W:= iota_noMod _ _ _ (eq_refl _) _ _ _ _ _ _ H2 x).
             rewrite modVars_iota in W. rewrite supd_Diff in W; try discriminate.
             remember (in_dec pvar_eq x (modVarsL C1)) as b; destruct b.
               rewrite modVarsChar' in MV1. exfalso. apply (MV1 i).
             apply (W MV2).
     rewrite <- W. clear H5 IHtw1 IHtw2.
       split. apply SIM. unfold MERGE; simpl. rewrite W2. rewrite W. apply leq_refl.
       apply SIM. unfold MERGE; simpl. rewrite W2. rewrite W. apply leq_refl.
(*While*)
remember N as IND. clear HeqIND N. rename N0 into N. rename H0 into IH.
assert (Goal1:= iota_ControlLabelsPreserved (While E C) F _ (eq_refl _) _ _ _ _ _ _ Hyp).
split; trivial.
rewrite fpcupd_Same in UU2. 
repeat rewrite FPCCTXT2CTXT_upd_pcVar in UU1.
remember (fresh F) as Fr. destruct Fr as [n Fn].
rename G into Gamma. rename G0 into G.
inversion Hyp'; subst; clear Hyp'. destruct r as [r' K'].
destruct (CompCode_Lemma0 _ _ _ _ _ _ H4) as [MC1 MC2]. subst. clear H4.
inversion Hyp; subst; clear Hyp. destruct r as [[r KK] MM].
inversion H3; subst; clear H3. rename r into s. rename KK into G.
inversion H5; subst; clear H5. destruct r as [[r K] Q].
destruct (mkJoins_effect _ _ _ _ _ _ _ _ H6) as [Z1 [Z2 Z3]]. apply eq_sym in Z1.  apply eq_sym in Z2. subst. clear H6.
repeat rewrite lab_eval_GEval in *.
rewrite (allPCs_conds_eq _ _ Q) in UU2; trivial.
assert (NinNF: In n (n::F)). left; trivial.
assert (HypCN:= IH IND). clear IH.
clear PreBelowN.
assert (PostPre: FSQSUB (post IND) (pre IND)).
  rewrite PreAboveN. rewrite PrePost.
  intros z. destruct z; unfold FLUB; simpl. rewrite fpcupd_Same. apply lubleft. apply lub_leqleft. 
  rewrite fpcupd_Diff. apply lub_leqleft. discriminate.
  trivial.
assert (PostPre': SQSUB (FPCCTXT2CTXT (post IND)) (FPCCTXT2CTXT (pre IND))).
  intros z. apply PostPre.
assert (HGN : FSQSUB Gamma (pre IND)).
  clear HypCN. 
  rewrite (PreAboveN IND). rewrite PrePost. 
  intros z. destruct z. rewrite fpcupd_Same. 
        unfold FLUB, llub; simpl. eapply @leq_trans with (y:=(lub (post IND pcVar) (Gamma pcVar))). apply lub_leqright.
         apply lub_leqleft. 
  rewrite fpcupd_Diff. unfold FLUB, llub; simpl.  apply lub_leqright. discriminate.
  apply Le.le_refl.
assert (UW := UWhile_cond_svar C _ _ _ _ _ _ _ _ _ H3). rewrite supd_Same in UW.
fold supd in UW.
destruct UW as [UW1 [UW2 [UW3 UW4]]].
    rewrite GEval_sep; simpl.
     apply lub_leq. apply lub_leqleft.
     apply lubright. rewrite GEval_supd_condsvar. rewrite zeval_app; simpl.
              rewrite zeval_GEval. apply lub_leqright.
(*follows from goal1 assert (UW22: forall m, In m F -> m <> n -> M (cond_svar m) = Q (cond_svar m)).
   intros. rewrite <- (UW2 m H H0). rewrite supd_Diff; trivial. intros Z; inversion Z; subst. apply H0; trivial.*)
clear UW2. 
intros x SIM.
cut (t x = t' x /\
       ssqsub (llub (D x)
              (if in_dec pvar_eq x (modVarsL C)
                  then llub (Q (cond_svar n)) (Q (var_svar (progVar x)))
                  else Q (var_svar (progVar x)))) (D' x)).
  intros GOAL; destruct GOAL as [Goal1a Goal2].
      split. apply Goal1a.
      apply Goal2.
destruct (MC2 x) as [[MCx MVx] | [MCx MVx]].
Focus 2.
(*~ In x (modVars C)*)
  remember (in_dec pvar_eq x (modVarsL C)) as b; destruct b. exfalso. apply modVarsChar' in MVx. apply (MVx i). clear Heqb n0.
  rewrite MCx in *.
  destruct (TSem1 _ _ _ _ _ H2 x) as [W1 W2]; clear H2. simpl. rewrite modVars_theta. apply MVx.
     rewrite <- W1 in *. rewrite <- W2 in *. clear W1 W2.
  destruct (JSem1 _ _ _ _ _ _ _ _ _ H3 x) as [W1 W2]; clear H3. simpl. rewrite modVars_iota. rewrite MVx. rewrite modVars_mkJoins. reflexivity.
     rewrite <- W1 in *. rewrite <- W2 in *. clear W1.
  assert (UW4x: M (var_svar (progVar x)) = (Q (var_svar (progVar x)))).
      rewrite <- (UW4 _ MVx). rewrite supd_Diff; try discriminate. trivial.
  rewrite <- UW4x.
  clear HypCN MC2.
  assert (SUB: ssqsub (MERGE G M x)
                (MERGE D
                   (fun y : SVar =>
                        match y with
                    | var_svar pcVar => Q (var_svar pcVar)
                    | var_svar (progVar yyy) =>
                        if in_dec pvar_eq yyy (modVarsL C)
                        then llub (Q (cond_svar n)) (Q (var_svar (progVar yyy)))
                        else Q (var_svar (progVar yyy))
                   | cond_svar m => Q (cond_svar m)
                    end) x)).
          unfold MERGE; simpl. rewrite UW4x. rewrite W2.
            apply lub_leq. apply lub_leqleft.
            apply lubright.
            remember (in_dec pvar_eq x (modVarsL C)) as b; destruct b; try apply leq_refl.
               apply lub_leqright.
  split; apply SIM; apply SUB.
(* In x (modVarsL C)*)
  rewrite MCx.
  remember (in_dec pvar_eq x (modVarsL C)) as b; destruct b. Focus 2. exfalso. apply n0. apply modVarsChar. assumption.
  clear MVx Heqb MC2. fold supd in *.
  remember (supd M (cond_svar n)
           (llub (GEval G E)
              (zeval SVar M (allPCs F ++ mkSVars E)))) as MM.
  assert (XMM : ssqsub (MM  (cond_svar n)) (llub (Gamma pcVar) (GEval (fun x0 : PVar => pre IND (progVar x0)) E))).
       clear HypCN H3 SIM; subst. rewrite supd_Same.
       rewrite PreAboveN. rewrite PrePost.
       apply lub_leq. apply lubright. eapply @leq_trans with (y:=(GEval (MERGE G M) E)).
                  apply GEval_mono. intros z; apply lub_leqleft.
               apply GEval_mono. eapply leq_trans. intros z. apply HG.
                 simpl. intros. rewrite fpcupd_Diff. unfold FLUB; simpl. apply lub_leqright. discriminate.
       rewrite zeval_app; simpl.
         apply lub_leq. apply lubleft. assumption. 
         rewrite zeval_GEval. simpl. apply lubright. eapply @leq_trans with (y:=(GEval (MERGE G M) E)).
                  apply GEval_mono. intros z; apply lub_leqright.
               apply GEval_mono. eapply leq_trans. intros z. apply HG.
                 simpl. intros. rewrite fpcupd_Diff. unfold FLUB; simpl. apply lub_leqright. discriminate.
       trivial.
  assert (HSMM: ssqsub (zeval SVar MM (allPCs (n::F))) (pre IND pcVar)).
    clear H3 HypCN. subst. simpl. rewrite supd_Same. 
    rewrite supd_Same in XMM. rewrite <- zeval_allPCs_supd; try (intros zz; apply (Fn zz)).
    assert (Z: ssqsub (Gamma pcVar) (pre IND pcVar)). apply HGN.
    apply lub_leq. eapply (leq_trans XMM). 
       remember ((llub (Gamma pcVar) (GEval (fun x0 : PVar => pre IND (progVar x0)) E))) as xx.
        rewrite PreAboveN. rewrite PrePost. rewrite fpcupd_Same. subst.
          unfold FLUB; simpl.  
          apply lub_leq. apply lubleft. apply lub_leqright.
          rewrite PreAboveN. rewrite PrePost. apply lubright. 
          eapply GEval_mono. intros z; simpl. rewrite fpcupd_Diff. apply leq_refl. discriminate.
         trivial.
        trivial.
    eapply (leq_trans HF). apply Z.
  assert (HMM: SQSUB (MERGE G MM) (FPCCTXT2CTXT (pre IND))).
    clear HypCN H3. 
      rewrite (PreAboveN IND). rewrite PrePost. rewrite FPCCTXT2CTXT_upd_pcVar.
      subst. intros z. unfold MERGE, FLUB, FPCCTXT2CTXT; simpl. rewrite supd_Diff; try discriminate.
      eapply leq_snart. apply lubright. apply HG. apply leq_refl.
    trivial.
  assert (HpcVarN: ssqsub (pre IND pcVar) (FPCCTXT2CTXT (pre IND) x)). 
    eapply leq_snart. apply PostPre.
    eapply FPC_Mod'. apply FPCT_FPC. apply HypC. apply modVarsChar. apply i.
  assert (SIMM : ssimsub 
          (llub (D x) (llub (Q (cond_svar n)) (Q (var_svar (progVar x)))))
          (fun x : PVar => llub (G x) (MM (var_svar (progVar x)))) G' s s').
    clear HypCN H2 H3. subst.
    intros z Hz. rewrite supd_Diff in Hz; try discriminate. rewrite supd_Diff; try discriminate. 
       apply SIM. unfold MERGE; simpl. 
       remember (in_dec pvar_eq x (modVarsL C)) as b; destruct b. apply Hz.
         exfalso. apply (n0 i).     
  assert (MMn: ssqsub (GEval (fun x0 : PVar => llub (G x0) (MM (var_svar (progVar x0)))) E)
                      (MM (cond_svar n))).
      clear HypCN SIMM H2 H3. subst. rewrite supd_Same. rewrite GEval_sep. simpl.
         apply lub_leq. apply lub_leqleft.
         apply lubright. assert (Z:= zeval_all_app F E M n (llub (GEval G E) (zeval SVar M (allPCs F ++ mkSVars E)))). rewrite <- Z. clear Z. 
              rewrite <- zeval_GEval. rewrite zeval_app. apply lubright. repeat rewrite <- zeval_zupd. apply leq_refl.
            intros ZZ. apply (Fn ZZ).  
  clear HeqMM HF HG. clear SIM UW1 Goal1 M PreZ.
  assert (SUBG' : SQSUB G' (FPCCTXT2CTXT (pre IND))). eapply leq_trans. apply HG'. intros z.  apply HGN.
  clear HGN HG' MCx. unfold ZStore in *.
  remember ((s, G), MM) as ST. remember (t, D, Q) as TT.
  remember (JWhile SVar E
          (JComp SVar (iota C (n :: F))
             (JComp SVar (mkJoins n (modVarsL C))
                (JJoin SVar (cond_svar n) (E :: nil)
                   (cond_svar n :: allPCs F ++ mkSVars E))))) as PP.
  generalize dependent Q. generalize dependent D. generalize dependent t. 
  generalize dependent MM. generalize dependent G. generalize dependent s.
  generalize dependent K'. generalize dependent t'. 
  generalize dependent G'. generalize dependent s'.
  induction H3; subst; try inversion HeqPP; clear HeqPP. subst; simpl in *.
  Focus 2. 
  (*False *) clear HypCN; intros; subst. simpl in *.
             apply eq_sym in HeqTT; inversion HeqTT; subst; clear HeqTT.
     assert (EV: eval s E = eval s' E).
       eapply ssimsub_eval. apply SIMM; clear SIMM.
         apply (leq_trans MMn). apply lubright. apply lub_leqleft.
     inversion H0; subst; clear H0; simpl in *.
     (*True*) simpl in *. rewrite EV in H. rewrite H in H3. inversion H3.
     (*False*) apply eq_sym in H6; inversion H6; subst; clear H6.
               split. apply SIMM. apply lub_leq. apply lub_leqleft.
                    apply lubright. apply lub_leqright.
               apply lub_leq. apply lubleft. eapply leq_snart. apply SIMM.
                                       apply lub_leq. apply lub_leqleft.
                                                      apply lubright. apply lub_leqright.
                                     apply lub_leqleft.
                  apply lub_leq. apply lubright. apply XMM.
                  apply lubleft. eapply leq_snart. apply SIMM.
                                       apply lub_leq. apply lub_leqleft.
                                                      apply lubright. apply lub_leqright.
                                     apply lub_leqright.
  (*True*) destruct s as [[s G] M]. destruct t as [[t K] QQ]. destruct r as [[r HH] PP].
           clear IHJoinSem1.
           intros. subst. apply eq_sym in HeqTT. inversion HeqTT; subst. apply eq_sym in HeqST. inversion HeqST; subst. clear HeqTT HeqST. 
           assert (IH := IHJoinSem2 (eq_refl _)); clear IHJoinSem2; simpl in *.
           inversion H3_; subst; clear H3_. destruct r0 as [[u A] P].
           inversion H6; subst; clear H6.
           inversion H8; subst; clear H8.
             destruct (mkJoins_effect _ _ _ _ _ _ _ _ H5) as [Z1 [Z2 Z3]]. subst. clear H5.
           assert (UV := UWhile_cond_svar C F n _ _ _ _ _ _ _ H3_0); clear H3_0. rewrite supd_Same in UV. 
           destruct UV as [UV1 [UV2 [UV3 UV4]]].
              rewrite GEval_sep; rewrite lab_eval_GEval; simpl. rewrite GEval_supd_condsvar.
              apply lub_leq. apply lub_leqleft.
              apply lubright. apply lubright.
              rewrite zeval_app; simpl. rewrite zeval_GEval. apply lub_leqright.
           apply lub_leq_elim in UV1. destruct UV1 as [UV11 UV12].
           simpl in UV12.
           apply lub_leq_elim in UV12. destruct UV12 as [UV121 UV122].
           assert (EV: eval s E = eval s' E).
             clear IH. eapply ssimsub_eval. apply SIMM; clear SIMM.                
             apply (leq_trans MMn). rewrite (iota_ControlLabelsPreserved C (n::F) _ (eq_refl _) _ _ _ _ _ _ H4).
                  apply lubright. apply lubleft. apply UV121.
               left; trivial.
           inversion H2; subst; clear H2.
           (*True*) simpl in *. destruct r as [u' A'].
               assert (SUBA'Post:= TntSem_FPC C _ _ (HypC IND) _ _ _ _ H6 SUBG').
               assert (SUBA': SQSUB A' (FPCCTXT2CTXT (pre IND))).
                  clear IH H8. eapply leq_trans. apply SUBA'Post. intros z. apply PostPre.
               destruct (Iota_FPC_U2 C _ _ (HypC IND) _ _ _ _ _ _ _ H4 HSMM HMM) as [ZZ1 ZZ2].
               destruct (HypCN _ _ _ _ _ _ _ H4 _ _ _ _ H6) as [HypC1 HypC2].
                 apply HSMM. apply HMM. apply SUBG'. apply ZZ1.  apply ZZ2.
               assert (IHH := IH u' A' SUBA' _ _ H8 u A _ (eq_refl _)); clear IH.
               fold supd in IHH. repeat rewrite supd_Same in IHH.
               rewrite lab_eval_GEval in IHH.
               rewrite (allPCs_conds_eq _ _ P) in IHH. 
               (*first the exploitation of the rewrite - the discharge of SC is below*)
                 repeat rewrite lab_eval_GEval in IHH. simpl in IHH. repeat rewrite supd_Same in IHH. simpl in IHH.
                 assert (SQSUBAP: SQSUB (MERGE A P) (FPCCTXT2CTXT (pre IND))).
                   clear IHH. eapply leq_trans. apply ZZ1. intros z. apply PostPre.
                 assert (SQA: SQSUB A (MERGE A P)). intros z. apply lub_leqleft.
                 assert (prenpc: pre IND pcVar = llub (FLUB (post IND) Gamma pcVar)
                           (GEval (fun x0 : PVar => FLUB (post IND) Gamma (progVar x0)) E)).
                   rewrite PreAboveN; trivial. rewrite PrePost; trivial.
                 assert (ESubPc: ssqsub (GEval (FPCCTXT2CTXT (pre IND)) E) (pre IND pcVar)).
                         rewrite prenpc. apply lubright.  apply GEval_mono.  rewrite PreAboveN; trivial. rewrite PrePost; trivial. rewrite FPCCTXT2CTXT_upd_pcVar. apply leq_refl.
                 assert (HPpcVar: ssqsub (GEval
                       (fun x0 : PVar =>
                          if in_dec pvar_eq x0 (modVarsL C)
                          then llub (P (cond_svar n)) (P (var_svar (progVar x0)))
                          else P (var_svar (progVar x0))) E) (pre IND pcVar)).
                   rewrite prenpc. apply lubright. apply GEval_mono.
                      intros z; simpl. unfold FLUB; simpl. apply lubleft. 
                          eapply leq_snart. apply ZZ1. apply lubright. 
                      remember (in_dec pvar_eq z (modVarsL C)) as b; destruct b; try apply leq_refl.
                        apply lub_leq; try apply leq_refl. eapply (iota_Mod C _ _ (eq_refl _) _ _ _ _ _ _ H4). rewrite modVars_iota. apply modVarsChar.  assumption. left; trivial.
                 remember (llub (P (cond_svar n))
                    (zeval SVar (fun y : SVar =>
                                 match y with
                                  | var_svar pcVar => P (var_svar pcVar)
                                  | var_svar (progVar yyy) =>
                                    if in_dec pvar_eq yyy (modVarsL C)
                                    then
                                      llub (P (cond_svar n)) (P (var_svar (progVar yyy)))
                                    else P (var_svar (progVar yyy))
                                  | cond_svar m => P (cond_svar m)
                                 end) (allPCs F ++ mkSVars E))) as k.
                 remember (supd
                          (fun y : SVar =>
                           match y with
                            | var_svar pcVar => P (var_svar pcVar)
                            | var_svar (progVar yyy) =>
                               if in_dec pvar_eq yyy (modVarsL C)
                               then llub (P (cond_svar n)) (P (var_svar (progVar yyy)))
                               else P (var_svar (progVar yyy))
                            | cond_svar m => P (cond_svar m)
                           end) (cond_svar n) (llub (GEval A E) k)) as YY.
                 assert (SC1: ssqsub (llub (GEval A E) k) (llub (Gamma pcVar) (GEval (fun x0 : PVar => pre IND (progVar x0)) E))).
                   clear IHH.
                   apply lub_leq. apply lubright. apply GEval_mono. eapply leq_trans. apply SQA. apply SQSUBAP.
                   subst. apply lub_leq. eapply leq_snart. apply XMM. rewrite <- HypC1. apply leq_refl. left; trivial.
                   rewrite zeval_app; simpl. rewrite (allPCs_conds_eq _ _ P); trivial.  
                   apply lub_leq. apply lubleft. eapply leq_snart. apply UU2. apply eq_leq.
                         apply allPCs_conds_eq. intros. rewrite <- UV2. rewrite supd_Diff. trivial. intros zz. inversion zz; subst. apply (Fn H0).
                            apply H0. intros zz. inversion zz; subst. apply (Fn H0). intros; trivial.
                   rewrite zeval_GEval. apply lubright. apply GEval_mono.
                             eapply leq_snart. apply SQSUBAP.
                          intros z. remember (in_dec pvar_eq z (modVarsL C)) as b; destruct b.
                             apply lub_leq. apply lubright. eapply (iota_Mod _ _ _ (eq_refl _) _ _ _ _ _ _ H4). rewrite modVars_iota. apply modVarsChar. apply i0.
                                  left; trivial.
                             apply lub_leqright. 
                           apply lub_leqright.                 
                 eapply (IHH SC1); clear IHH.
                 (*9 futher indhyp side conditions*)
                 (*9*) 
                   apply lub_leq. eapply (leq_trans SC1). rewrite prenpc. unfold FLUB; simpl.
                      apply lub_leq. apply lubleft. apply lub_leqright. 
                      eapply (leq_trans ESubPc). rewrite prenpc. apply eq_leq. reflexivity.
                   eapply leq_snart. eapply PostPre. eapply leq_snart. apply ZZ2. simpl. apply lub_leqright.
                 (*8*) unfold MERGE; simpl. 
                     intros z.
                     apply lub_leq.
                         eapply leq_snart. apply SQSUBAP. apply MERGE_L.
                     subst. rewrite supd_Diff; try discriminate.
                           remember (in_dec pvar_eq z (modVarsL C)) as b; destruct b; try apply leq_refl.
                            apply lub_leq; try apply leq_refl. 
                            eapply leq_trans. apply (iota_Mod C _ _ (eq_refl _) _ _ _ _ _ _ H4 z).  rewrite modVars_iota. apply modVarsChar.  assumption. left; trivial.
                              eapply leq_snart. apply SQSUBAP. apply MERGE_R. 
                          eapply leq_snart. apply SQSUBAP. apply MERGE_R.
                     eapply leq_snart. apply SQSUBAP. apply MERGE_R.
                 (*7*) rewrite GEval_sep; simpl.
                     apply lub_leq. apply lub_leqleft.
                     apply lubright. subst. apply lubright. rewrite zeval_app. apply lubright. 
                            rewrite zeval_GEval. rewrite GEval_supd_condsvar. apply leq_refl.
                 (*6*) apply UU1.
                 (*5*) apply UU2.
                 (*4*) reflexivity.
                 (*3*) apply UV3.
                 (*2*) intros. subst. rewrite supd_Diff; try discriminate. 
                          rewrite <- (UV4 _ H0). rewrite supd_Diff; try discriminate. trivial.
                 (*1*) intros z Hz. subst. rewrite supd_Diff; try discriminate. rewrite supd_Diff in Hz; try discriminate.
                       assert (HPP: (if in_dec pvar_eq z (modVarsL C)
                                   then llub (P (cond_svar n)) (P (var_svar (progVar z)))
                                   else P (var_svar (progVar z))) = P (var_svar (progVar z))).
                          remember (in_dec pvar_eq z (modVarsL C)) as b; destruct b; trivial.
                            apply eq_sym. apply ccompat_llub. eapply (iota_Mod _ _ _ (eq_refl _) _ _ _ _ _ _ H4). rewrite modVars_iota. apply modVarsChar. apply i0.
                                left; trivial.
                      rewrite HPP in *.
                      apply HypC2. 
                         intros y Hy. apply SIMM. eapply (leq_trans Hy). apply Hz.
             (*here's the discharge of the SC of the rewrite above*)
               intros. rewrite supd_Diff. trivial. intros Z. inversion Z. subst. apply (Fn H0).
           (*False*) simpl in *. apply eq_sym in H7.
                     rewrite EV in H. rewrite H in H5. inversion H5.
Qed.

Lemma iota_below_theta: forall C Gamma Delta (tw:FPCT Gamma C Delta) s' G' t' D' 
(HypT: TntSem (s',G') (theta _ _ _ tw) (t', D'))
s G M t D N F
(HypJ: JoinSem _ SVar_eq (s,G,M) (iota C F) (t,D,N))
(SUBG: SQSUB (MERGE G M) G')
(SUBG': SQSUB G' (FPCCTXT2CTXT Gamma))
(SUBF: ssqsub (zeval SVar M (allPCs F)) (Gamma pcVar)) x
(HB: eq_below (MERGE D N x) (MERGE G M) s s'),
t x = t' x /\ ssqsub (MERGE D N x) (D' x). 
Proof.
intros.
assert (SUB1: SQSUB (MERGE G M) (FPCCTXT2CTXT Gamma)).
  eapply leq_trans. apply SUBG.  apply SUBG'.
destruct (iota_theta _ _ _ tw _ _ _ _ _ _ _ HypJ _ _ _ _ HypT SUB1 SUBG' SUBF) as [_ Z].
apply Z.
  intros z Hz.
  split. apply HB. apply Hz.
  apply SUBG.
Qed.   

(*This formulation corresponds to Theorem 5 in paper*)
Lemma iota_below_theta_MERGE: 
forall C Gamma Delta (tw:FPCT Gamma C Delta) s' G M t' D' 
(HypT: TntSem (s',MERGE G M) (theta _ _ _ tw) (t',D'))
s t D N F
(HypJ: JoinSem _ SVar_eq (s,G,M) (iota C F) (t,D,N))
(SUBG': SQSUB (MERGE G M) (FPCCTXT2CTXT Gamma))
(SUBF: ssqsub (zeval SVar M (allPCs F)) (Gamma pcVar)) x
(HB: eq_below (MERGE D N x) (MERGE G M) s s'),
t x = t' x /\ ssqsub (MERGE D N x) (D' x). 
Proof.
intros.
eapply iota_below_theta. apply HypT. apply HypJ. apply leq_refl. assumption. assumption. assumption.
Qed. 

Lemma iota_below_theta_MERGE_kappa: 
forall C Gamma Delta (tw:FPCT Gamma C Delta) s' G M t' D' 
(HypT: TntSem (s',MERGE G M) (theta _ _ _ tw) (t',D'))
s t D N F
(HypJ: JoinSem _ SVar_eq (s,G,M) (iota C F) (t,D,N))
(SUBG': SQSUB (MERGE G M) (FPCCTXT2CTXT Gamma))
(SUBF: ssqsub (zeval SVar M (allPCs F)) (Gamma pcVar)) kappa
(HB: eq_below kappa (MERGE G M) s s'),
eq_below kappa (MERGE D N) t t'.
Proof.
intros.
intros x Hx.
eapply iota_below_theta. apply HypT. apply HypJ. apply leq_refl. assumption. assumption.
eapply eq_below_mono. apply HB. apply Hx. apply leq_refl.
Qed. 