Require Export AXBASE.

Class MAP (DOM:Type) 
          (DOM_dec: forall d d':DOM, {d=d'} + {d <> d'})
          (RNG:Type)
          (M_upd: (DOM -> RNG) -> DOM -> RNG -> (DOM -> RNG)) : Type
:=
Mfacts{
  M_upd_char: forall m x a, M_upd m x a = 
     fun y => if DOM_dec x y then a else m y
}.
  
Lemma M_upd_Same {DOM dec RNG M_upd} `{MAP DOM dec RNG M_upd}:  
  forall G x v, M_upd G x v x = v. 
Proof.  intros. 
rewrite M_upd_char. 
remember (dec x x) as b; destruct b; simpl.  trivial. 
apply False_ind.  apply n; trivial. 
Qed. 

Lemma M_upd_Diff {DOM dec RNG M_upd} `{MAP DOM dec RNG M_upd}:  
forall G x v y, x <> y -> M_upd G x v y = G y. 
Proof. intros. 
rewrite M_upd_char. 
remember (dec x y) as b; destruct b; subst; simpl. 
  apply False_ind.  apply H0. trivial. 
 trivial. 
Qed. 

Lemma M_upd_split {DOM dec RNG M_upd} `{MAP DOM dec RNG M_upd}: 
forall s x v t,  t x = v ->
 (forall y, x <> y -> s y = t y) ->
 M_upd s x v = t.
Proof.
intros.
rewrite M_upd_char. (*unfold M_upd.*)
apply extensionality. intros y.
remember (dec x y) as b; destruct b; subst; simpl. trivial. apply (H1 _ n). 
Qed.

Lemma M_upd_split_at {DOM dec RNG M_upd} `{MAP DOM dec RNG M_upd}: 
forall s x v y u, (x = y -> v = u) ->
                  (x <> y -> s y = u) ->
                   M_upd s x v y = u.
Proof.
intros.
rewrite M_upd_char. (* unfold M_upd.*)
remember (dec x y) as b; destruct b; subst; simpl. 
  apply H0. trivial.
  apply (H1 n). 
Qed.

Lemma M_upd_upd {DOM dec RNG M_upd} `{MAP DOM dec RNG M_upd}: 
forall s x v u, M_upd (M_upd s x u) x v = M_upd s x v.
Proof.
intros.
apply extensionality.
intros z.
apply M_upd_split_at; intros; subst.
  rewrite M_upd_Same. trivial.
  repeat rewrite M_upd_Diff; try assumption. trivial.
Qed.

Lemma M_upd_upd_swap {DOM dec RNG M_upd} `{MAP DOM dec RNG M_upd}: 
forall s x y u v (XY:  x <> y), 
        M_upd (M_upd s x u) y v = M_upd (M_upd s y v) x u.
Proof.
intros.
apply extensionality.
intros z.
apply M_upd_split_at; intros; subst.
  rewrite M_upd_Diff; try assumption.
    rewrite M_upd_Same. trivial.
apply M_upd_split_at; intros; subst.
    rewrite M_upd_Same. trivial.
  rewrite M_upd_Diff; try assumption.
  rewrite M_upd_Diff; try assumption. trivial.
Qed.